// --------------------------------------------------------------------
// Author  : mashimonator
// Create  : 2009/11/21
// Update  : 2009/11/21
//         : 2009/12/28 IE6で発生していたエラーを修正
// Description : リンクに指定されたファイルの情報を自動で取得してtooltipで表示する
// --------------------------------------------------------------------

/*@cc_on 
var doc = document;
eval('var document = doc');
@*/
var fileLinkExtension = {
	//-----------------------------------------
	// 設定値
	//-----------------------------------------
	conf : {
		extension : [ '.png', '.gif', '.jpg', '.jpeg', '.pdf', '.xlsx', '.xls', '.docx', '.doc', '.pptx', '.ppt', '.zip', '.lzh', '.cab', '.txt', '.exe' ], // tooltipを表示する対象の拡張子
		tooltipColor : 'black', // tooltipの色 --> 'black','white','red','green'
		header : '', // ツールチップの冒頭に挿入するテキスト（htmlタグ使用可）
		footer : '' // ツールチップの末尾に挿入するテキスト（htmlタグ使用可）
	},
	storage : {
		dispTimer : null,
		hideTimer : null,
		tooltip : null,
		content : null,
		shim : null
	},
	//-----------------------------------------
	// 初期処理
	//-----------------------------------------
	init : function() {
		var elements = document.getElementsByTagName('A');
		for ( var i = 0, len = elements.length; i < len; i++ ) {
			for (var x = 0, len2 = fileLinkExtension.conf.extension.length; x < len2; x++) {
				var href = elements[i].getAttribute('href');
				var reg = new RegExp( fileLinkExtension.conf.extension[x] + '$', 'i' );
				if ( href.match(reg) ) {
					// 対象リンクにイベント付加
					fileLinkExtension.addEvent(elements[i], 'mouseover', fileLinkExtension.over);
					fileLinkExtension.addEvent(elements[i], 'mouseout', fileLinkExtension.out);
				}
			}
		}
		if ( elements && elements.length > 0 ) {
			// tooltip生成
			fileLinkExtension.createTooltip();
			// shim生成
			fileLinkExtension.createShim();
		}
	},
	//-----------------------------------------
	// over時の処理
	//-----------------------------------------
	over : function() {
		fileLinkExtension.view(this);
	},
	//-----------------------------------------
	// out時の処理
	//-----------------------------------------
	out : function() {
		fileLinkExtension.hide();
	},
	//-----------------------------------------
	// tooltipを表示する
	//-----------------------------------------
	view : function( element ) {
		// Timerリセット
		window.clearTimeout(fileLinkExtension.storage.dispTimer);
		window.clearTimeout(fileLinkExtension.storage.hideTimer);
		// ファイル情報を取得
		var text = fileLinkExtension.getFileInfo(element);
		if ( text ) {
			// tooltipのテキストをセット
			fileLinkExtension.storage.content.innerHTML = text;
			// tooltipの設定
			var linkPos = fileLinkExtension.getElementPosition(element);
			var tooltipSize = fileLinkExtension.getElementSize(fileLinkExtension.storage.tooltip);
			fileLinkExtension.setPosition(fileLinkExtension.storage.tooltip, linkPos.top - tooltipSize.height, linkPos.left);
			fileLinkExtension.setOpacity(fileLinkExtension.storage.tooltip, 0);
			fileLinkExtension.storage.tooltip.style.visibility = 'visible';
			// shimの設定
			fileLinkExtension.setSize(fileLinkExtension.storage.shim, tooltipSize.width, tooltipSize.height);
			fileLinkExtension.setPosition(fileLinkExtension.storage.shim, linkPos.top - tooltipSize.height, linkPos.left);
			fileLinkExtension.storage.shim.style.visibility = 'visible';
			// fadeIn開始
			fileLinkExtension.fadeIn();
		}
	},
	//-----------------------------------------
	// tooltipを非表示にする
	//-----------------------------------------
	hide : function() {
		// Timerリセット
		window.clearTimeout(fileLinkExtension.storage.dispTimer);
		window.clearTimeout(fileLinkExtension.storage.hideTimer);
		// fadeOut開始
		fileLinkExtension.fadeOut();
	},
	//-----------------------------------------
	// tooltipのフェード制御（表示）
	//-----------------------------------------
	fadeIn : function() {
		// 不透明度を取得
		var opacity = fileLinkExtension.getOpacity(fileLinkExtension.storage.tooltip);
		if ( 8.7 > opacity ) {
			// 不透明度セット
			fileLinkExtension.setOpacity(fileLinkExtension.storage.tooltip, opacity+1);
			fileLinkExtension.storage.dispTimer = window.setTimeout(fileLinkExtension.fadeIn, 50);
		} else {
			// 不透明度セット
			fileLinkExtension.setOpacity(fileLinkExtension.storage.tooltip, 8.7);
		}
	},
	//-----------------------------------------
	// tooltipのフェード制御（非表示）
	//-----------------------------------------
	fadeOut : function() {
		// 不透明度を取得
		var opacity = fileLinkExtension.getOpacity(fileLinkExtension.storage.tooltip);
		if ( opacity > 0 ) {
			// 不透明度セット
			fileLinkExtension.setOpacity(fileLinkExtension.storage.tooltip, opacity-1);
			fileLinkExtension.storage.hideTimer = window.setTimeout(fileLinkExtension.fadeOut, 50);
		} else {
			// tooltipを非表示
			fileLinkExtension.setOpacity(fileLinkExtension.storage.tooltip, 0);
			fileLinkExtension.storage.tooltip.style.visibility = 'hidden';
			fileLinkExtension.setPosition(fileLinkExtension.storage.tooltip, 0, 0);
			// shimを非表示
			fileLinkExtension.storage.shim.style.visibility = 'hidden';
			fileLinkExtension.setSize(fileLinkExtension.storage.shim, 1, 1);
			fileLinkExtension.setPosition(fileLinkExtension.storage.shim, 0, 0);
		}
	},
	//-----------------------------------------
	// tooltipを生成する
	//-----------------------------------------
	createTooltip : function() {
		// tooltip生成
		var parentDiv = document.createElement('div');
		switch (fileLinkExtension.conf.tooltipColor) {
			case 'black':
				parentDiv.className = 'fileInfoTooltip blackTooltip';
				break;
			case 'white':
				parentDiv.className = 'fileInfoTooltip whiteTooltip';
				break;
			case 'red':
				parentDiv.className = 'fileInfoTooltip redTooltip';
				break;
			case 'green':
				parentDiv.className = 'fileInfoTooltip greenTooltip';
				break;
			default:
				parentDiv.className = 'fileInfoTooltip blackTooltip';
				break;
		}
		parentDiv.style.zIndex = '200';
		parentDiv.style.visibility = 'hidden';
		document.body.appendChild(parentDiv);
		// content生成
		var contentDiv = document.createElement('div');
		contentDiv.className = 'fileInfoTooltipContent';
		contentDiv.innerHTML = String.fromCharCode(8203);
		parentDiv.appendChild(contentDiv);
		// arrow生成
		var arrowDiv = document.createElement('div');
		arrowDiv.style.zIndex = '201';
		arrowDiv.className = 'fileInfoTooltipArrow';
		for (var i = 10; i > 0; i--) {
			var lineDiv = document.createElement('div');
			lineDiv.className = 'fileInfoLine' + i;
			lineDiv.innerHTML = String.fromCharCode(8203);
			arrowDiv.appendChild(lineDiv);
		}
		parentDiv.appendChild(arrowDiv);
		// 初期位置セット
		fileLinkExtension.setPosition(parentDiv, 0, 0);
		// 保持
		fileLinkExtension.storage.tooltip = parentDiv;
		fileLinkExtension.storage.content = contentDiv;
	},
	//-----------------------------------------
	// shimを生成する
	//-----------------------------------------
	createShim : function() {
		// iframe要素を生成
		var iframe = document.createElement('iframe');
		// スタイルをセット
		iframe.setAttribute('frameBorder', '0');
		iframe.setAttribute('scrolling', 'no');
		iframe.style.border = 'none';
		iframe.style.zIndex = '150';
		iframe.style.visibility = 'hidden';
		fileLinkExtension.setSize(iframe, 1, 1);
		fileLinkExtension.setPosition(iframe, 0, 0);
		fileLinkExtension.setOpacity(iframe, 0);
		document.body.appendChild(iframe);
		// 保持
		fileLinkExtension.storage.shim = iframe;
	},
	//-----------------------------------------
	// 要素の不透明度を取得する
	//-----------------------------------------
	getOpacity : function( element ) {
		var opacity = 0;
		if ( element.alpha ) {
			opacity = element.alpha / 10;
		} else if ( element.style ) {
			if ( element.style.opacity ) {
				opacity = element.style.opacity * 10;
			}
		}
		if ( 0 > opacity ) {
			opacity = 0;
		}
		return opacity;
	},
	//-----------------------------------------
	// 要素の不透明度を設定する
	//-----------------------------------------
	setOpacity : function( element, val ) {
		element.style.opacity = val / 10;
		element.style.filter = 'alpha(opacity=' + val * 10 + ')';
		element.alpha = val * 10;
	},
	//-----------------------------------------
	// 要素のサイズを設定する
	//-----------------------------------------
	setSize : function( element, width, height ) {
		element.style.width = width + 'px';
		element.style.height = height + 'px';
	},
	//-----------------------------------------
	// 要素の位置を設定する
	//-----------------------------------------
	setPosition : function( element, top, left ) {
		element.style.position = 'absolute';
		element.style.top = top + 'px';
		element.style.left = left + 'px';
	},
	//-----------------------------------------
	// 対象要素のポジションを取得する
	//-----------------------------------------
	getElementPosition : function( element ) {
		var offsetTrail = (typeof element == 'string') ? document.getElementById(element): element;
		var x = 0;
		var y = 0;
		while (offsetTrail) {
			x += offsetTrail.offsetLeft;
			y += offsetTrail.offsetTop;
			offsetTrail = offsetTrail.offsetParent;
		}
		if ( navigator.userAgent.indexOf('Mac') != -1 && typeof doc.body.leftMargin != 'undefined' ) {
			x += document.body.leftMargin;
			y += document.body.topMargin;
		}
		return ({ 'left': x, 'top': y });
	},
	//-----------------------------------------
	// 対象要素のサイズを取得する
	//-----------------------------------------
	getElementSize : function( element ) {
		var w = element.offsetWidth;
		var h = element.offsetHeight;
		return ({ 'width': w, 'height': h });
	},
	// -----------------------------------
	// ファイル情報を取得する
	// -----------------------------------
	getFileInfo : function( element ) {
		// HTTP通信用オブジェクト生成
		var httpObj = fileLinkExtension.createXMLHttpRequest();
		if ( !httpObj ) {
			// Not support HTTP connection
			return false;
		}
		// 同期通信
		httpObj.open('HEAD', element.href, false);
		try {
			httpObj.send(null);
		} catch(e) {
			// 404 Not Found
			return false;
		}
		// 結果を取得
		if ( httpObj.readyState != 4 || httpObj.status != 200 ) {
			return false;
		}
		var text = new Array;
		// --- ヘッダ
		if ( fileLinkExtension.conf.header != '' ) {
			text.push(fileLinkExtension.conf.header);
			text.push('<br />');
		}
		// --- ファイル名
		text.push('ファイル：&nbsp;');
		var name = element.href.split('/');
		text.push(name[name.length-1]);
		text.push('&nbsp;<br />');
		// --- 最終更新日
		text.push('更新日：&nbsp;');
		if ( !httpObj.getResponseHeader('Last-Modified') ) {
			return false;
		} else {
			var date = new Date(httpObj.getResponseHeader('Last-Modified'));
			date = date.getFullYear() + '/' + (date.getMonth() + 1) + '/' + date.getDate();
			text.push(date);
		}
		text.push('&nbsp;<br />');
		// --- ファイルサイズ
		text.push('サイズ：&nbsp;');
		if ( !httpObj.getResponseHeader('Content-Length') ) {
			return false;
		} else {
			text.push(fileLinkExtension.convUnit(httpObj.getResponseHeader('Content-Length')));
		}
		text.push('&nbsp;');
		// --- フッタ
		if ( fileLinkExtension.conf.footer != '' ) {
			text.push('<br />');
			text.push(fileLinkExtension.conf.footer);
		}
		return text.join('');
	},
	// -----------------------------------
	// 単位を変換する
	// -----------------------------------
	convUnit : function( num ) {
		if ( num > 1073741824 ) {
			// GByte
			num = num / (1024*1024*1024);
			return Math.ceil(num) + 'GB';
		} else if ( num > 1048576 ) {
			// MByte
			num = num / (1024*1024);
			return Math.ceil(num) + 'MB';
		} else if ( num > 1024 ) {
			// KByte
			num = num / 1024;
			return Math.ceil(num) + 'KB';
		} else {
			// byte
			return Math.ceil(num) + 'byte';
		}
	},
	// -----------------------------------
	// HTTP通信用オブジェクト生成
	// -----------------------------------
	createXMLHttpRequest : function() {
		var XMLhttpObject = null;
		try {
			XMLhttpObject = new XMLHttpRequest();
		} catch(e) {
			var progids = new Array('MSXML2.XMLHTTP.5.0', 'MSXML2.XMLHTTP.4.0', 'MSXML2.XMLHTTP.3.0', 'MSXML2.XMLHTTP', 'Microsoft.XMLHTTP');
			for (var i = 0, len = progids.length; i < len; i++) {
				try {
					XMLhttpObject = new ActiveXObject(progids[i]);
				} catch (e) {
					XMLhttpObject = null;
				}
			}
		}
		return XMLhttpObject;
	},
	//-----------------------------------------
	// イベントに関数を付加する
	//-----------------------------------------
	addEvent : function( target, event, func ) {
		try {
			target.addEventListener(event, func, false);
		} catch (e) {
			target.attachEvent('on' + event, (function(el){return function(){func.call(el);};})(target));
		}
	}
}
// 実行
fileLinkExtension.addEvent( window, 'load', fileLinkExtension.init );